//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3E09E033C.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3E09E033C.cm

//## begin module%39A3E09E033C.cp preserve=no
//## end module%39A3E09E033C.cp

//## Module: XspecDataIO%39A3E09E033C; Package specification
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/XspecDataIO.h

#ifndef XSPECDATAIO_H
#define XSPECDATAIO_H 1

//## begin module%39A3E09E033C.additionalIncludes preserve=no
//## end module%39A3E09E033C.additionalIncludes

//## begin module%39A3E09E033C.includes preserve=yes
//## end module%39A3E09E033C.includes

// Error
#include <XSUtil/Error/Error.h>

class SpectralData;

//## begin module%39A3E09E033C.declarations preserve=no
//## end module%39A3E09E033C.declarations

//## begin module%39A3E09E033C.additionalDeclarations preserve=yes
//## end module%39A3E09E033C.additionalDeclarations


//## Class: XspecDataIO%39A3E113002F
//	XspecIO is an interface to be attached to Data classes
//	requiring that they define a read() and write()
//	operation.
//
//	The subclasses, which are data format specific, supply a
//	default implementation for each type, which will
//	read/write the spectrum information for each data
//	format. This will take care of the DataSet, Background,
//	and Correction file read/writes. They will then be
//	overridden in the Response read/write operations.
//
//	Also, OGIP2 may override the default implementation for
//	OGIP. Both read/write operations must be virtual.
//
//	In Xspec 11-, write() operations are scarce. It is
//	intended that the write() operation for SfIO produces
//	OGIP format output. The OGIP write() operation can also
//	be reused for writing FakeData. Einstein SSS data could
//	also be EOLed by writing the data as OGIP.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39DE4878018E;SpectralData { -> F}

class XspecDataIO 
{
  public:
    //## Class: CannotOpen%39A3F4C501B0
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class CannotOpen : public YellowAlert  //## Inherits: <unnamed>%39A3F55D025C
    {
      public:
        //## Constructors (generated)
          CannotOpen();

        //## Constructors (specified)
          //## Operation: CannotOpen%39A3F4F102A5
          CannotOpen (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## begin XspecDataIO::DataType%39CF62090353.preface preserve=yes
    //## end XspecDataIO::DataType%39CF62090353.preface

    //## Class: DataType%39CF62090353
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {SpectrumType,ResponseType,AuxResponseType} DataType;

    //## begin XspecDataIO::DataType%39CF62090353.postscript preserve=yes
    //## end XspecDataIO::DataType%39CF62090353.postscript

    //## Class: RequiredDataNotPresent%3A2D32D801BD
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class RequiredDataNotPresent : public YellowAlert  //## Inherits: <unnamed>%3A2D33350307
    {
      public:
        //## Constructors (specified)
          //## Operation: RequiredDataNotPresent%3A2D32FD002C
          RequiredDataNotPresent (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: SingleSpectrumOnly%3A02D7F703A0
    //	Exception to be thrown if the user tried to specify
    //	spectrum numbers to read from a file containing a single
    //	spectrum.
    //	This exception will be absorbed silently (spectrum
    //	number ignored): its function is to halt the loop after
    //	the spectrum is read in the case that the user specified
    //	multiple spectra
    //	from the file.
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class SingleSpectrumOnly : public YellowAlert  //## Inherits: <unnamed>%3A02EA0900A9
    {
      public:
        //## Constructors (specified)
          //## Operation: SingleSpectrumOnly%3A02D81200BF
          SingleSpectrumOnly (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: UnspecifiedSpectrumNumber%3A02D84D007A
    //	Exception to be thrown if the data file contains multiple
    //	spectra and the user did not specify which is to be read.
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class UnspecifiedSpectrumNumber : public YellowAlert  //## Inherits: <unnamed>%3A02EA1602D1
    {
      public:
        //## Constructors (specified)
          //## Operation: UnspecifiedSpectrumNumber%3A02D89102CA
          UnspecifiedSpectrumNumber (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: CatchAllIO%3EA408F7002C
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class CatchAllIO : public YellowAlert  //## Inherits: <unnamed>%3EA40A710299
    {
      public:
        //## Constructors (specified)
          //## Operation: CatchAllIO%3EA40AD80010
          CatchAllIO (const string& msg);

      protected:
      private:
      private: //## implementation
    };


    //## Other Operations (specified)
      //## Operation: read%39A3E1470105
      virtual size_t read (const string& fileName, bool readFlag = true) = 0;

      //## Operation: write%39A3E1520014
      virtual void write (const string& fileName) = 0;

      //## Operation: fileFormat%39AD44B40361
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType) = 0;

  public:
  protected:
    //## Constructors (generated)
      XspecDataIO();

    //## Destructor (generated)
      virtual ~XspecDataIO() = 0;


    //## Other Operations (specified)
      //## Operation: channelBounds%39FDA84A0283
      //	Function to find the channel bounds in the analysis
      //	version of the data
      //	read from the source file.
      //
      //	The array size is modified from the total number of
      //	data lines read by possible start/end channel keywords
      //	(TLMINn, TLMAXn in OGIP files, where n is the
      //	number of the column with the channel numbers).
      virtual void channelBounds (int& startChannel, int& endChannel, size_t row = 0) const = 0;

  private:
    //## Assignment Operation (generated)
      XspecDataIO & operator=(const XspecDataIO &right);

  private: //## implementation
};

// Class XspecDataIO::CannotOpen 

// Class XspecDataIO::RequiredDataNotPresent 

// Class XspecDataIO::SingleSpectrumOnly 

// Class XspecDataIO::UnspecifiedSpectrumNumber 

// Class XspecDataIO::CatchAllIO 

// Class XspecDataIO 

//## begin module%39A3E09E033C.epilog preserve=yes
//## end module%39A3E09E033C.epilog


#endif
